<?php

class Service_LSPLConnector extends XcBase {

      var $_kernel;

        function Service_LSPLConnector($kernelLink) {
           $this->_localname = 'LSPLConnector';
           $this->XcBase($kernelLink);
           $this->_kernel = $this->srvMainKernel();
           //$this->advOnto = $this->_kernel->srvFactory("AdvOntology");
        }

        function onInstall($params) {

           return true;
    }


    function onUninstall($params) {

           return true;
    }

    function runLSPLFindTask($text, $patterns, $tasks) {
      $rootPath = $this->_kernel->getRootPath();

      $lsplpath = dirname(__FILE__).'/lspl/bin';

      $tmpfile = tempnam('/tmp','');
      file_put_contents($tmpfile, $text);

      $tmpfileP = tempnam('/tmp','');
      file_put_contents($tmpfileP, $patterns);

      //echo $lsplpath."\n";
      if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
          //Win
          //$cmd = 'set RML="'.$lsplpath.'/../data"';
          putenv('RML="'.$lsplpath.'/../data"');
          /*
          exec($cmd);
          echo $cmd."\n";
          $curdir = getcwd();
          shell_exec($lsplpath);
          */
          $cmd .= $lsplpath.'/lspl-find.exe -i "'.$tmpfile.'" -p "'.$tmpfileP.'" "'.$tasks.'"';
          //$cmd = "dir";
          //echo $cmd."\n";
          $res = shell_exec($cmd);
          shell_exec($curdir);
      } else {
          // FreeBSD
          /*
          shell_exec('export RML="'.$lsplpath.')/../data"')
          $res = shell_exec(dirname(__FILE__)."/mystem/mystem -cl ".$tmpfile);
          */
      }

      unlink($tmpfile);
      unlink($tmpfileP);
      //echo $res;
      return $res;
    }


}


?>
